<?php


$inFile = "in.xml";
$outFile = "out.csv";
if(isset($argv[1])) $inFile = $argv[1];
if(isset($argv[2])) $outFile = $argv[2];

$xml = simplexml_load_file($inFile);
$ns = $xml->getNamespaces(true);
print_r($ns);
$colNames = Null;
$out = fopen($outFile,"wt");

foreach($xml->channel as $channel)
foreach($channel->item as $item)
{
	//Set the column names based on the first item
	if($colNames === Null)
	{
		$colNames = array();
		foreach($item->children() as $k => $child)
		{	
			array_push($colNames, $k);
			echo $k."\n";
			fwrite($out,'"'.$k.'",');
		}

		foreach($ns as $nspace => $nsv)
		{
			foreach($item->children($nspace,TRUE) as $k => $c)
			{
				array_push($colNames, $nspace.":".$k);
				echo $nspace.":".$k."\n";
				fwrite($out,'"'.$nspace.":".$k.'",');
			}
		}

		fwrite($out,"\n");
	}

	//Get the data into an array
	$data = array();
	foreach($item->children() as $k => $child)
	{
		$data[$k] = (string)$child;
	}
	//print_r($data);

	//echo $item->child("title")."\n";
	foreach($ns as $nspace => $nsv)
	{
		foreach($item->children($nspace,TRUE) as $k => $c)
			$data[$nspace.":".$k] = (string)$c;
	}

	//Output array in order of column headings
	foreach($colNames as $col)
	{
		if(isset($data[$col]))
		{
		$val = $data[$col];
		fwrite($out,'"'.$val.'",');
		}
		else
			fwrite($out,',');
	}
	fwrite($out,"\n");
}


?>
