<?php
session_start();
require_once('config.php');
require_once('dbutils.php');
require_once('activity.php');

$masterdb = new GenericSqliteTable("var/master.db","master");
$externaldb = new GenericSqliteTable("var/externaldb.db","external");

if(!isset($masterdb[$_GET['id']]))
	die("No such ID");

$record = $masterdb[$_GET['id']];
$external = $externaldb[$_GET['id']];
$nameCol = GetConfigOption('nameCol');

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<!--
Design by Free CSS Templates
http://www.freecsstemplates.org
Released for free under a Creative Commons Attribution 2.5 License

Name       : Tomatoes
Description: A two-column, fixed-width design for 1024x768 screen resolutions.
Version    : 1.0
Released   : 20110301

-->
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="content-type" content="text/html; charset=utf-8" />
<title><?php echo GetConfigOption('overallTitle').", ".GetConfigOption('subTitle');?></title>
<meta name="keywords" content="" />
<meta name="description" content="" />
<link href="style.css" rel="stylesheet" type="text/css" media="screen" />
</head>
<body>
<div id="wrapper">
	<div id="header">
		<div id="menu">
			<ul>
				<?php $pageCatExplore = 1;
				require('topbar.php'); ?>
			</ul>
		</div>
		<!-- end #menu -->
	</div>
	<div id="logo">
		<h1><a href="#"><?php echo GetConfigOption('overallTitle');?></a></h1>
		<p><em><?php echo GetConfigOption('subTitle');?></em></p>
	</div>
	<hr />
	<!-- end #logo -->
	<div id="page">
		<div id="page-bgtop">
			<div id="content">

<?php
//*****************
//Process Post Form
//*****************
$captchaFailed = 0;
if(isset($_POST['osmid']) and !GetConfigOption('readOnly'))
{
	if(GetConfigOption('enableCaptcha'))
	{	
	require_once('recaptcha-php-1.11/recaptchalib.php');
	$privatekey = GetConfigOption('recaptchaPrivate');;
	$resp = recaptcha_check_answer ($privatekey,
	                       $_SERVER["REMOTE_ADDR"],
	                       $_POST["recaptcha_challenge_field"],
	                       $_POST["recaptcha_response_field"]);

	if (!$resp->is_valid) {
	  // What happens when the CAPTCHA was entered incorrectly
	  $captchaFailed = 1;
	}
	}

	if(!$captchaFailed)
	{
	//print_r($_POST);
	$newex = array();
	$newex['nickname'] = substr($_POST['nickname'],0,$maxnickname);
	$newex['timestamp'] = time();
	$newex['db'] = "osm";
	$newex['type'] = substr($_POST['osmtype'],0,10);
	$newex['id'] = (int)($_POST['osmid']);
	$newex['license'] = "CC0";
	$newex['karma'] = 1;
	$newex['uuid'] = uniqid();
	$_SESSION['nickname'] = $newex['nickname'];
	
	if(!isset($external['external']))
		$external['external'] = array();
	array_push($external['external'], $newex);
	$externaldb[$_GET['id']] = $external;

	AddActivityEvent($record[$nameCol]." Linked",$newex['nickname']." added a database link for ".$record[$nameCol]." on ".htmlspecialchars(date("F j, Y, g:i a",$newex['timestamp'])),$newex['nickname'],"details.php?id=".$_GET['id'],$newex['uuid']);	


?>
				<div class="post">
					<h2 class="title"><a href="#">Thank you for your submission!</a></h2>
					<div class="entry">
						<p><a href="details.php?id=<?php echo $_GET['id'];?>">Continue</a></p>
					</div>
				</div>


<?php
	}

	if($captchaFailed)
	{
?>
				<div class="post">
					<h2 class="title"><a href="#">Captcha Problem</a></h2>
					<div class="entry">
					<p>There was a problem with the anti-spam test. Please try again.</p>
					</div>
				</div>

<?php
	}
}

//*****************
//Form
//*****************

if(!isset($_POST['osmid']) or $captchaFailed)
{
if(!isset($_SESSION['nickname'])) $_SESSION['nickname'] = "Anonymous";

?>

				<div class="post">
					<h2 class="title"><a href="#">Link to External OSM Database</a></h2>
					<div class="entry">
					<form method="post" action="">
					<p>Your nickname: <input type="text" name="nickname" value="<?php echo $_SESSION['nickname']; ?>"/></p>
					<p><input type="radio" name="osmtype" value="node" /> Node<br />
					<input type="radio" name="osmtype" value="way" /> Way <br/>
					<input type="radio" name="osmtype" value="relation" /> Relation
					</p>
					<p>ID: <input type="text" name="osmid" value=""/></p>
					<p>You agree to waive any copyright, database right, and any other rights that may be waived, over submitted information, as specified in the <a href="http://creativecommons.org/choose/zero/">CC0 license</a>. This enables others to use your knowledge in innovative ways.</p> 
						<p><a href="details.php?id=<?php echo $_GET['id'];?>">Cancel</a></p>
<?php
if(GetConfigOption('enableCaptcha'))
{
	require_once('recaptcha-php-1.11/recaptchalib.php');
	$publickey = GetConfigOption('recaptchaPublic');
	echo recaptcha_get_html($publickey);
}
?>

					<p><input type="submit" value="Submit" /></p>
					</form>
					</div>
				</div>

<?php
}

?>

			</div>
			<!-- end #content -->
			<div id="sidebar">
				<ul>
					<?php require('sidebar.php'); ?>

				</ul>
			</div>
			<!-- end #sidebar -->
			<div style="clear: both;">&nbsp;</div>
		</div>
	</div>
	<!-- end #page -->
	<div id="footer">

<?php
	require_once('footer.php');
?>
	</div>
	<!-- end #footer -->
</div>
</body>
</html>
