<?php

require_once('dbutils.php');

function GetLocationPosts($id)
{
	$locationdb = new GenericSqliteTable("var/locations.db","locations");
	$locations = $locationdb[$id];

	$annots = array();
	if(isset($locations['locations']))
	foreach ($locations['locations'] as $loc)
	{
		//print_r($loc);
		$n = array();
		$n['title'] = $loc['source']." Position";
		$n['nickname'] = $loc['nickname'];
		$n['timestamp'] = $loc['timestamp'];
		$n['karma'] = $loc['karma'];
		$n['uuid'] = $loc['uuid'];

		$body = "<p>".$loc['source']." at ".$loc['lat'].", ".$loc['lon'].". View on ";
		$body .= "<a href=\"http://www.openstreetmap.org/?mlat=".$loc['lat']."&amp;mlon=".$loc['lon']."&amp;zoom=14\">OpenStreetMap</a>, ";
		$body .= "<a href=\"http://maps.google.co.uk/?ie=UTF8&amp;ll=".$loc['lat'].",".$loc['lon']."&amp;t=h&amp;z=5&amp;q=Marker@".$loc['lat'].",".$loc['lon']."\">Google</a>";
		$body .= "</p>";

		if(strlen($loc['comment'])>0)
			$body .= "<p>".htmlspecialchars($loc['comment'])."</p>";		
		$n['body'] = $body;

		array_push($annots,$n);
	}
	return $annots;
}

function ChangeKarmaLocationPosts($id,$uuid,$vote)
{
	$locationsdb = new GenericSqliteTable("var/locations.db","locations");
	$locations = $locationsdb[$id];

	if(isset($locations['locations']))
	foreach ($locations['locations'] as $index => $com)
	{
		if($com['uuid'] != $uuid) continue;
		$locations['locations'][$index]['karma'] += (int)$vote;
		$locationsdb[$id] = $locations;
	}
}

function GetBestLocation($id)
{
	$locationdb = new GenericSqliteTable("var/locations.db","locations");
	$locations = $locationdb[$id];

	$bestloc = Null;
	$besttime = Null;
	$bestrough = Null;
	$bestsource = Null;
	$bestlicense = Null;
	$bestkarma = Null;
	$best = Null;
	if(!isset($locations['locations'])) return array(Null,Null);
	foreach ($locations['locations'] as $loc)
	{
		if(($besttime == Null or $loc['timestamp'] > $besttime) and
			($bestkarma == Null or $loc['karma']>= $bestkarma))
		{
			//if($loc['roughposition'] and $bestrough===FALSE) continue; //Don't choose a rough position, if we have an exact one.
			$bestloc = array($loc['lat'],$loc['lon']);
			$besttime = $loc['timestamp'];
			$bestrough = $loc['roughposition'];
			$bestsource = $loc['source'];
			$bestlicense = $loc['license'];
			$bestkarma = $loc['karma'];
			$best = $loc;
		}

	}
	if ($best===Null)
	{
		return array(Null,Null,'source'=> Null, 'license'=> Null, 
		'nickname'=>Null);
	}

	return array($bestloc,$bestrough, 'source'=> $bestsource, 'license'=> $bestlicense, 
		'nickname'=>$best['nickname']);
}

function LatLonToCartesian($lat, $lon)
{
	//Assume spherical Earth
	$r = 6378.1;

	$lat = deg2rad($lat);
	$lon = deg2rad($lon);

	$x = $r * sin($lat) * cos($lon);
	$y = $r * sin($lat) * sin($lon);
	$z = $r * cos($lat);

	return array($x,$y,$z);
}

function PythagDist($p1, $p2)
{
	$out = 0.0;
	for($i=0;$i<count($p1);$i++)
	{
		$out += pow($p1[$i] - $p2[$i],2.0);
	}
	return pow($out,0.5);
}

function GenerateViewHtml($lat,$lon,$marker="Marker")
{
	$out = "View on ";
	
	$out .= "<a href=\"http://www.openstreetmap.org/?mlat=".$lat."&amp;mlon=".$lon."&amp;zoom=14\">OpenStreetMap</a>, ";
	$out .= "<a href=\"http://toolserver.org/~geohack/geohack.php?pagename=".$marker."&params=".$lat."_N_".$lon."_E_type:landmark_region:GB\">GeoHack</a>, ";
	$out .= "<a href=\"http://maps.google.com/maps?ll=".$lat.",".$lon."&spn=0.01,0.01&t=m&q=".$lat.",".$lon."\">Google</a>, ";
	$out .= "<a href=\"http://maps.bing.com/default.aspx?v=2&cp=51.392253~0.537574&style=r&lvl=15&sp=Point.".$lat."_".$lon."_".$marker."___\">Bing</a>.";
	return $out;
}

?>
